function setup_player(objects)
	objects.player = {}

	objects.player = {}
	objects.player.spawnpoint = math.random(1,#viable_spawn_points)
	objects.player.body = love.physics.newBody(world, viable_spawn_points[objects.player.spawnpoint][2]+25,viable_spawn_points[objects.player.spawnpoint][1]+25,"dynamic")
	objects.player.shape = love.physics.newRectangleShape(60,60)
	objects.player.fixture = love.physics.newFixture(objects.player.body, objects.player.shape, 1)
	objects.player.velocity_cap = 400
	objects.player.speed = 5000
	objects.player.body:setFixedRotation(true)

    objects.player.update = function (player) 
        player_update(player)
    end

end

function player_update(player)
	--move the player
    local is_moving = {}
	is_moving.up = love.keyboard.isDown("w")
	is_moving.down = love.keyboard.isDown("s")
	is_moving.left = love.keyboard.isDown("a")
	is_moving.right = love.keyboard.isDown("d")
   

    if is_moving.up then
    	objects.player.body:applyForce(0,-objects.player.speed)
    end
    if is_moving.down then
    	objects.player.body:applyForce(0,objects.player.speed)
    end
    if is_moving.left then
    	objects.player.body:applyForce(-objects.player.speed,0)
    end
    if is_moving.right then
    	objects.player.body:applyForce(objects.player.speed,0)
    end

	if not(is_moving.up or is_moving.down or is_moving.left or is_moving.right) then
		objects.player.body:setLinearVelocity(0,0)
	end
    --cap the velocity
    local body_x_velocity, body_y_velocity = objects.player.body:getLinearVelocity()
    if body_x_velocity > objects.player.velocity_cap then
    	objects.player.body:setLinearVelocity(objects.player.velocity_cap,body_y_velocity)
    elseif body_x_velocity < -objects.player.velocity_cap then
    	objects.player.body:setLinearVelocity(-objects.player.velocity_cap,body_y_velocity)
    end
    local body_x_velocity, body_y_velocity = objects.player.body:getLinearVelocity()
    if body_y_velocity > objects.player.velocity_cap then
    	objects.player.body:setLinearVelocity(body_x_velocity,objects.player.velocity_cap)
    elseif body_y_velocity < -objects.player.velocity_cap then
    	objects.player.body:setLinearVelocity(body_x_velocity,-objects.player.velocity_cap)
    end
    --[[
    if is_moving.up == false then
        local body_x_velocity, body_y_velocity = objects.player.body:getLinearVelocity()
        if body_y_velocity > -10 then
            objects.player.body:setLinearVelocity(body_x_velocity,0)
        else
            objects.player.body:setLinearVelocity(body_x_velocity,body_y_velocity/2)
        end
    end
    if is_moving.down == false then
        local body_x_velocity, body_y_velocity = objects.player.body:getLinearVelocity()
        if body_y_velocity < 10 then
            objects.player.body:setLinearVelocity(body_x_velocity,0)
        else
            objects.player.body:setLinearVelocity(body_x_velocity,body_y_velocity/2)
        end
    end
]]
end
