function generate_map(columns,rows,min_room_width,min_room_height,max_room_height,max_room_width)
	map={}
	math.randomseed(os.time())
	math.random(); math.random(); math.random()
	for i=0,rows do
		table.insert(map,{})	
	end
	for key,value in ipairs(map) do
		for i=0,columns do
			table.insert(value,1) --solid tile value. Add in quads?
		end
	end
	--draw initial room
	room_tiles={}
	room_tiles.actual_tiles={}
	startingroom_x=math.floor(columns/2)
	startingroom_y=math.floor(rows/2)
	map[startingroom_y][startingroom_x] = 2 --empty out a tile
	startingroom_xtwo=math.random(min_room_width,max_room_width) + startingroom_x
	startingroom_ytwo=math.random(min_room_width,max_room_height) + startingroom_y -- these are the second points. used for determining length.
	
	
	room_border_tiles = {}
	room_border_tiles.checking={} --for use with the setContains.. functions
	room_border_tiles.strips={} --for use of the creation of the the solid walls to avoid the "crack" collision problem
	--determine the borders
	--local strip = {}
	for i=startingroom_x, startingroom_xtwo - 1 do --NOTE: coordinates are deposited in here as [y,x] for better use with the map array
		--table.insert(strip,{startingroom_y-1,i,"top"})
		table.insert(room_border_tiles,{startingroom_y-1,i,"top"}) 
		addToSet(room_border_tiles.checking,(startingroom_y-1)..i)
	end
	--table.insert(room_border_tiles.strips,strip)

	--local strip = {}
	for i=startingroom_x, startingroom_xtwo -1 do
		--table.insert(room_border_tiles.strips,{startingroom_ytwo,i,"bottom"})
		table.insert(room_border_tiles,{startingroom_ytwo,i,"bottom"})
		addToSet(room_border_tiles.checking,(startingroom_ytwo)..i)
	end
	--table.insert(room_border_tiles.strips,strip)

	--local strip = {}
	for i=startingroom_y, startingroom_ytwo -1 do
		--table.insert(room_border_tiles.strips,{i,startingroom_x -1,"left"})
		table.insert(room_border_tiles,{i,startingroom_x -1,"left"})
		addToSet(room_border_tiles.checking,i..(startingroom_x-1))
	end
	--table.insert(room_border_tiles.strips,strip)

	--local strip = {}
	for i=startingroom_y, startingroom_ytwo -1 do
		--table.insert(room_border_tiles.strips,{i,startingroom_xtwo,"right"})
		table.insert(room_border_tiles,{i,startingroom_xtwo,"right"})
		addToSet(room_border_tiles.checking,i..startingroom_xtwo)
	end
	--table.insert(room_border_tiles.strips,strip)

	local number_of_tries=0 --stop the loop when this equals 'bout 10 .. or 100
	while number_of_tries <= 100 do
		local selected_tile=math.random(#room_border_tiles) --changes for testing. Remember to change back.
		choice = math.random(1,2) --determine what kind of structure to build next
		if choice == 1 then --room
			if room_border_tiles[selected_tile][3] == "top" then 
				nextroom_xtwo = math.random(min_room_width,max_room_width)
				nextroom_ytwo = math.random(min_room_height,max_room_height)
				nextroom_x = room_border_tiles[selected_tile][2] - math.floor(nextroom_xtwo/2)
				nextroom_y = room_border_tiles[selected_tile][1] - nextroom_ytwo
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
			elseif room_border_tiles[selected_tile][3] == "bottom" then
				nextroom_xtwo = math.random(min_room_width,max_room_width)
				nextroom_ytwo = math.random(min_room_height,max_room_height) 
				nextroom_x = room_border_tiles[selected_tile][2] - math.floor(nextroom_xtwo/2)
				nextroom_y = room_border_tiles[selected_tile][1] + 1
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
			elseif room_border_tiles[selected_tile][3] == "left" then
				nextroom_xtwo = math.random(min_room_width,max_room_width)
				nextroom_ytwo = math.random(min_room_height,max_room_height) 
				nextroom_x = room_border_tiles[selected_tile][2] - nextroom_xtwo
				nextroom_y = room_border_tiles[selected_tile][1] - math.floor(nextroom_ytwo/2)
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
			elseif room_border_tiles[selected_tile][3] == "right" then
				nextroom_xtwo = math.random(min_room_width,max_room_width)
				nextroom_ytwo = math.random(min_room_height,max_room_height) 
				nextroom_x = room_border_tiles[selected_tile][2] + 1
				nextroom_y = room_border_tiles[selected_tile][1] - math.floor(nextroom_ytwo/2)
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
			end
		elseif choice == 2 then --corridor
			if room_border_tiles[selected_tile][3] == "top" then
				nextroom_xtwo = math.random(min_room_width,max_room_width) - min_room_width + 1
				nextroom_ytwo = 2
				nextroom_x = room_border_tiles[selected_tile][2] - math.floor(nextroom_xtwo/2)
				nextroom_y = room_border_tiles[selected_tile][1] - nextroom_ytwo
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
			elseif room_border_tiles[selected_tile][3] == "bottom" then
				nextroom_xtwo = math.random(min_room_width,max_room_width) - min_room_width + 1
				nextroom_ytwo = 2
				nextroom_x = room_border_tiles[selected_tile][2] - math.floor(nextroom_xtwo/2)
				nextroom_y = room_border_tiles[selected_tile][1] + 1
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
			elseif room_border_tiles[selected_tile][3] == "left" then
				nextroom_xtwo = math.random(min_room_width,max_room_width) + min_room_width
				nextroom_ytwo = 2
				nextroom_x = room_border_tiles[selected_tile][2] - nextroom_xtwo
				nextroom_y = room_border_tiles[selected_tile][1] - math.floor(nextroom_ytwo/2)
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
			elseif room_border_tiles[selected_tile][3] == "right" then
				nextroom_xtwo = math.random(min_room_width,max_room_width) + min_room_width
				nextroom_ytwo = 2
				nextroom_x = room_border_tiles[selected_tile][2] + 1
				nextroom_y = room_border_tiles[selected_tile][1] - math.floor(nextroom_ytwo/2)
				nextroom_xtwo = nextroom_xtwo + nextroom_x
				nextroom_ytwo = nextroom_ytwo + nextroom_y
				--table.insert(room_border_tiles,{nextroom_x,nextroom_y,"top"})
			end
		end

		if not pcall(draw_room,nextroom_x,nextroom_xtwo,nextroom_y,nextroom_ytwo,map,rows,columns,room_border_tiles.checking) then
			number_of_tries = number_of_tries + 1
			goto continue
		end
		for i=nextroom_x,nextroom_xtwo - 1 do
			for i_two=nextroom_y,nextroom_ytwo - 1 do			
				addToSet(room_tiles,i..i_two) --x,y
				table.insert(room_tiles.actual_tiles,{i,i_two})
			end
		end
		for i=nextroom_x, nextroom_xtwo -1 do --NOTE: coordinates are deposited in here as [y,x] for better use with the map array
			--table.insert(room_border_tiles.strips,{nextroom_y-1,i,"top"})
			addToSet(room_border_tiles.checking,(nextroom_y-1)..i)
			table.insert(room_border_tiles,{nextroom_y-1,i,"top"}) 
		end
		for i=nextroom_x, nextroom_xtwo -1 do
			--table.insert(room_border_tiles.strips,{nextroom_ytwo,i,"bottom"})
			addToSet(room_border_tiles.checking,nextroom_ytwo..i) 
			table.insert(room_border_tiles,{nextroom_ytwo,i,"bottom"})
		end
		for i=nextroom_y, nextroom_ytwo -1 do
			--table.insert(room_border_tiles.strips,{i,nextroom_x -1,"left"})
			addToSet(room_border_tiles.checking,i..(nextroom_x-1)) 
			table.insert(room_border_tiles,{i,nextroom_x -1,"left"})
		end
		for i=nextroom_y, nextroom_ytwo -1 do
			--table.insert(room_border_tiles.strips,{i,nextroom_xtwo,"right"})
			addToSet(room_border_tiles.checking,i..nextroom_xtwo) 
			table.insert(room_border_tiles,{i,nextroom_xtwo,"right"})
		end
		--now how to remove these tiles from the strip?
		map[room_border_tiles[selected_tile][1]][room_border_tiles[selected_tile][2]]=2 --empty out the seleted tile
		--local strip_info = access_strip(selected_tile)
		--table.insert(room_border_tiles.strips,get_and_remove_every_element_after(strip_info[3],room_border_tiles.strips[strip_info[2]]))
		--table.remove(room_border_tiles.strips[strip_info[2]],strip_info[3])
		--[[local direction_of_addon = math.random(1,2)
		if direction_of_addon == 1 then
			direction_of_addon = 1
		elseif direction_of_addon == 2 then
			direction_of_addon = -1
		end]]
		if choice == 1 then
			if (room_border_tiles[selected_tile][3] == "top")  or (room_border_tiles[selected_tile][3] == "bottom") then
				map[room_border_tiles[selected_tile][1]][room_border_tiles[selected_tile][2]-1] = 2
				--table.remove(room_border_tiles.strips[strip_info[2]],strip_info[3]-1)
			end
			if (room_border_tiles[selected_tile][3] == "left") or (room_border_tiles[selected_tile][3] == "right") then
				pcall(safe_index,map,room_border_tiles,selected_tile)
				--pcall(function () table.remove(room_border_tiles.strips[strip_info[2]],strip_info[3]) end)
			end
		end
		--table.remove(room_border_tiles,selected_tile)
		--removeFromSet(room_border_tiles.checking,room_border_tiles[selected_tile][1]..room_border_tiles[selected_tile][2])
		::continue::
	end

	for rowIndex,row in ipairs(map) do
		for columnIndex, column in ipairs(row) do
			if setContains(room_tiles,columnIndex..rowIndex) or setContains(room_border_tiles.checking,rowIndex..columnIndex) then
				goto continue
			else
				map[rowIndex][columnIndex]=1
			end
			::continue::
		end
	end
	for i=startingroom_x ,startingroom_xtwo -1 do
		for i_two=startingroom_y,startingroom_ytwo -1 do
			map[i_two][i] = 2
			addToSet(room_tiles,i_two..i)
		end
	end
	for y,v in ipairs(map) do
		for x,v in ipairs(v) do
			if map[y][x] == 1 and (not setContains(room_border_tiles.checking,y..x)) then
				map[y][x] = 0
			end
		end
	end
	--[[for i,v in ipairs(room_border_tiles) do
		if v[3] == "top" then
		elseif v[3] == "bottom" then
		elseif v[3] == "right" then
		elseif v[3] == "left" then
		end
	end]]
	return map,room_border_tiles
end

function draw_room(x,xtwo,y,ytwo,map,rows,columns,border_tiles)
	local record = {}
	for i=x ,xtwo - 1 do --loop to draw the next room
		for i_two=y,ytwo - 1 do
			if i == 1 or i_two == 1 then
				goto if_errror			
			elseif map[i_two][i] == 2 then
				goto if_errror
			elseif setContains(border_tiles,i_two..i) then
				goto if_errror
			elseif i_two > rows or i > columns then
				goto if_errror
			elseif (i == 1 or i == columns) or (i_two == 1 or i_two == rows) then
				goto if_errror
			end 
			map[i_two][i] = 2
			table.insert(record,{i,i_two}) --x,y
		end
	end
	goto quickend
	::if_errror::
	for i,v in ipairs(record) do
		map[v[2]][v[1]] = 1
	end
	error("Those spaces were already empty")
	::quickend::
end

function addToSet(set, key)
    set[key] = true
end

function removeFromSet(set, key)
    set[key] = nil
end

function setContains(set, key)
    return set[key] == true
end
function safe_index(map,room_border_tiles,selected_tile) 
	map[room_border_tiles[selected_tile][1]-1][room_border_tiles[selected_tile][2]] = 2 
end
function draw_map(map,TileW,TileH,Quads,Tileset)
 for rowIndex,row in ipairs(map) do --note: ipairs is slightly less efficient than loop above
  for columnIndex,tile in ipairs(row) do
  	if tile == 0 then
  		local x,y = (columnIndex-1)*TileW, (rowIndex-1)*TileH
   		love.graphics.draw(Tileset, Quads[1], x, y)
   		goto continue
  	end
   local x,y = (columnIndex-1)*TileW, (rowIndex-1)*TileH
   love.graphics.draw(Tileset, Quads[tile], x, y)
   ::continue::
  end
 end
end

function create_quads(QuadInfo,tileW,tileH,TilesetW, TilesetH)
  Quads = {}
  for i,info in ipairs(QuadInfo) do
  Quads[i] = love.graphics.newQuad(info[1], info[2], tileW, tileH, TilesetW, TilesetH) --create quads
 end
 return Quads
end

function access_strip(index)
	local reference_index = 0
	for i,v in ipairs(room_border_tiles.strips) do
		for index,key in ipairs(v) do
			reference_index = reference_index + 1
			if reference_index == index then
				return {room_border_tiles.strips[i][index],i,index}
			end
		end
	end
end

function get_and_remove_every_element_after(index,arg_table)
	local length = #arg_table
	local return_table = {}
	for i,v in ipairs(arg_table) do
		if i > index then
			table.insert(return_table,v)
			table.remove(arg_table, i)
		end
	end
	return return_table
end